<?php

/**
* Lists stats
* @return array
* @param string $sDateFrom
* @param string $sDateTo
*/
function listStats( $sDateFrom, $sDateTo, $bProducts = null ){
  if( $bProducts === true ){
    $sFile = DB_PRODUCTS_STATS;
    $oProduct = ProductsAdmin::getInstance( );
  }
  else{
    $sFile = DB_PAGES_STATS;
    $oPage = PagesAdmin::getInstance( );
  }
  if( !is_file( $sFile ) )
    file_put_contents( $sFile, '<?php exit; ?>'."\n" );
  $rF = fopen( $sFile, 'r' );
  $aStats = null;
  $i = 0;
  $iTimeStart = strtotime( $sDateFrom );
  $iTimeStop =  strtotime( $sDateTo.' 23:59:59' );
  while( ( $aFile = fgetcsv( $rF, 30, '$' ) ) !== FALSE ){
    if( $i > 0 ){
      $aData = dbAssignStats( $aFile );
      if( $aData['iTime'] >= $iTimeStart && $aData['iTime'] <= $iTimeStop ){
        if( isset( $aStats[$aData['iId']] ) )
          $aStats[$aData['iId']]++;
        else
          $aStats[$aData['iId']] = 1;
      }
    }
    $i++;
  }
  fclose( $rF );

  $aReturn['sContent'] = null;
  if( isset( $aStats ) && is_array( $aStats ) ){
    arsort( $aStats );

    foreach( $aStats as $iId => $iStats ){
      $aIds[] = $iId;
    } // end foreach
    $iCount = count( $aIds );
    $aKeys = countPageNumber( $iCount, ( isset( $_GET['iPage'] ) ? $_GET['iPage'] : null ) );

    for( $i = $aKeys['iStart']; $i < $aKeys['iEnd']; $i++ ){
      $aData['iId'] = $aIds[$i];
      $aData['iVisits'] = $aStats[$aData['iId']];

      if( isset( $oPage->aPages[$aData['iId']]['sName'] ) )
        $aData['sName'] = $oPage->aPages[$aData['iId']]['sName'];
      elseif( isset( $oProduct->aProducts[$aData['iId']]['sName'] ) )
        $aData['sName'] = $oProduct->aProducts[$aData['iId']]['sName'];
      else
        $aData['sName'] = $aData['iId'];
    
      $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
      $aReturn['sContent'] .= '<tr class="l'.$aData['iStyle'].'"><td><a href="?p='.$GLOBALS['p'].'&amp;iId='.$aData['iId'].'">'.$aData['sName'].'</a></td><td>'.$aData['iVisits'].'</td></tr>';
    } // end for
  }

  if( isset( $aReturn['sContent'] ) ){
    $aReturn['sPages'] = countPagesClassic( $iCount, $GLOBALS['config']['admin_list'], $aKeys['iPageNumber'], changeUri( $_SERVER['REQUEST_URI'] ) );
    return $aReturn;
  }
} // end function listStats

/**
* Lists stats
* @return string
* @param int $iId
*/
function listStatsForElement( $iId, $bProducts = null ){
  if( $bProducts === true )
    $sFile = DB_PRODUCTS_STATS;
  else
    $sFile = DB_PAGES_STATS;
  if( !is_file( $sFile ) )
    file_put_contents( $sFile, '<?php exit; ?>'."\n" );
  $rF = fopen( $sFile, 'r' );
  $aStats = null;
  $i = 0;
  while( ( $aFile = fgetcsv( $rF, 30, '$' ) ) !== FALSE ){
    if( $i > 0 ){
      $aData = dbAssignStats( $aFile );
      if( $aData['iId'] == $iId ){
        $sTime = displayDate( $aData['iTime'], $GLOBALS['config']['date_format_admin_stats'] );
        if( isset( $aStats[$sTime] ) )
          $aStats[$sTime]++;
        else
          $aStats[$sTime] = 1;
      }
    }
    $i++;
  }
  fclose( $rF );

  $content = null;
  if( isset( $aStats ) && is_array( $aStats ) ){
    krsort( $aStats );
    $i = 0;
    foreach( $aStats as $aData['sDate'] => $aData['iVisits'] ){
      $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
      $content .= '<tr class="l'.$aData['iStyle'].'"><td>'.$aData['sDate'].'</td><td>'.$aData['iVisits'].'</td></tr>';
      $i++;
    } // end for
  }

  if( isset( $content ) )
    return $content;
} // end function listStatsForElement

/**
* Lists stats
* @return string
* @param string $sDateFrom
* @param string $sDateTo
*/
function listSearchedPhrases( $sDateFrom, $sDateTo ){
  global $oPage;
  if( !is_file( DB_SEARCHED_WORDS ) )
    file_put_contents( DB_SEARCHED_WORDS, '<?php exit; ?>'."\n" );
  $rF = fopen( DB_SEARCHED_WORDS, 'r' );
  $aStats = null;
  $i = 0;
  $iTimeStart = strtotime( $sDateFrom );
  $iTimeStop =  strtotime( $sDateTo.' 23:59:59' );
  while( ( $aFile = fgetcsv( $rF, 500, '$' ) ) !== FALSE ){
    if( $i > 0 ){
      $aData = dbAssignSearchedWords( $aFile );
      if( $aData['iTime'] >= $iTimeStart && $aData['iTime'] <= $iTimeStop ){
        if( isset( $aStats[$aData['sWords']] ) )
          $aStats[$aData['sWords']]++;
        else
          $aStats[$aData['sWords']] = 1;
      }
    }
    $i++;
  }
  fclose( $rF );

  $aReturn['sContent'] = null;
  if( isset( $aStats ) && is_array( $aStats ) ){
    arsort( $aStats );

    foreach( $aStats as $sPhrase => $iStats ){
      $aIds[] = $sPhrase;
    } // end foreach

    $iCount = count( $aIds );
    $aKeys = countPageNumber( $iCount, ( isset( $_GET['iPage'] ) ? $_GET['iPage'] : null ) );

    for( $i = $aKeys['iStart']; $i < $aKeys['iEnd']; $i++ ){
      $aData['sPhrase'] = $aIds[$i];
      $aData['iSearched'] = $aStats[$aData['sPhrase']];
      $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
      $aReturn['sContent'] .= '<tr class="l'.$aData['iStyle'].'"><td>'.$aData['sPhrase'].'</td><td>'.$aData['iSearched'].'</td></tr>';
    } // end for
  }

  if( isset( $aReturn['sContent'] ) ){
    $aReturn['sPages'] = countPagesClassic( $iCount, $GLOBALS['config']['admin_list'], $aKeys['iPageNumber'], changeUri( $_SERVER['REQUEST_URI'] ) );
    return $aReturn;
  }
} // end function listSearchedPhrases

/**
* Lists stats
* @return array
* @param string $sDateFrom
* @param string $sDateTo
*/
function listFilesStats( $sDateFrom, $sDateTo ){
  global $oPage;
  if( !is_file( DB_FILES_STATS ) )
    file_put_contents( DB_FILES_STATS, '<?php exit; ?>'."\n" );
  clearFilesStats( );
  $rF = fopen( DB_FILES_STATS, 'r' );
  $aStats = null;
  $i = 0;
  $iTimeStart = strtotime( $sDateFrom );
  $iTimeStop =  strtotime( $sDateTo.' 23:59:59' );
  while( ( $aFile = fgetcsv( $rF, 100, '$' ) ) !== FALSE ){
    if( $i > 0 ){
      $aData = dbAssignFilesStats( $aFile );
      if( $aData['iTime'] >= $iTimeStart && $aData['iTime'] <= $iTimeStop ){
        if( isset( $aStats[$aData['sFile']] ) )
          $aStats[$aData['sFile']]++;
        else
          $aStats[$aData['sFile']] = 1;
      }
    }
    $i++;
  }
  fclose( $rF );

  $aReturn['sContent'] = null;
  if( isset( $aStats ) && is_array( $aStats ) ){
    arsort( $aStats );

    foreach( $aStats as $sFile => $iStats ){
      $aFiles[] = $sFile;
    } // end foreach
    $iCount = count( $aFiles );
    $aKeys = countPageNumber( $iCount, ( isset( $_GET['iPage'] ) ? $_GET['iPage'] : null ) );

    for( $i = $aKeys['iStart']; $i < $aKeys['iEnd']; $i++ ){
      $aData['sFile'] = $aFiles[$i];
      $aData['iDownloads'] = $aStats[$aData['sFile']];
    
      $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
      $aReturn['sContent'] .= '<tr class="l'.$aData['iStyle'].'"><td>'.$aData['sFile'].'</td><td>'.$aData['iDownloads'].'</td></tr>';
    } // end for
  }

  if( isset( $aReturn['sContent'] ) ){
    $aReturn['sPages'] = countPagesClassic( $iCount, $GLOBALS['config']['admin_list'], $aKeys['iPageNumber'], changeUri( $_SERVER['REQUEST_URI'] ) );
    return $aReturn;
  }
} // end function listFilesStats

/**
* Removes deleted files from database with files stats
* @return void
*/
function clearFilesStats( ){
  if( !isset( $_SESSION['iClearFilesStatsLast'] ) || $_SESSION['iClearFilesStatsLast'] < ( time() - 600 ) ){
    $aChecked = Array();
    $aFile = file( DB_FILES_STATS );
    $iCount = count( $aFile );
    $rF = fopen( DB_FILES_STATS, 'w' );
    flock( $rF, LOCK_EX );
    fwrite( $rF, '<?php exit; ?>'."\n" );
    for( $i = 1; $i < $iCount; $i++ ){
      $aFile[$i] = rtrim( $aFile[$i] );
      $aExp = explode( '$', $aFile[$i] );
      if( isset( $aChecked[$aExp[0]] ) ){
      }
      elseif( is_file( DIR_FILES.$aExp[0] ) )
        $aChecked[$aExp[0]] = 1;
      else
        $aChecked[$aExp[0]] = 0;
      if( $aChecked[$aExp[0]] === 1 )
        fwrite( $rF, $aFile[$i]."\n" );
    } // end for
    flock( $rF, LOCK_UN );
    fclose( $rF );
    $_SESSION['iClearFilesStatsLast'] = time();
  }
} // end function clearFilesStats

/**
* Delete page stats
* @return void
* @param array $mIds
*/
function deleteStats( $mIds, $bProducts = null ){
  if( $bProducts === true )
    $sDb = DB_PRODUCTS_STATS;
  else
    $sDb = DB_PAGES_STATS;
  $sNewFile = $sDb.'.new';
  $rFB = fopen( $sNewFile, 'w' );
  @chmod( $sNewFile, 0644 );
  fwrite( $rFB, '<?php exit; ?>'."\n" );
  $rF = fopen( $sDb, 'r' );
  $i = 0;
  while( ( $aFile = fgetcsv( $rF, 30, '$' ) ) !== FALSE ){
    if( $i > 0 ){
      $aData = dbAssignStats( $aFile );
      if( $bProducts === true && $mIds == $aData['iId'] ){}
      elseif( isset( $mIds[$aData['iId']] ) ){}
      else
        fwrite( $rFB, $aData['iId'].'$'.$aData['iTime'].'$'."\n" );
    }
    $i++;
  }
  fclose( $rFB );
  fclose( $rF );
  copy( $sNewFile, $sDb );
  @chmod( $sDb, 0644 );
  unlink( $sNewFile );
} // end function deleteStats

/**
* Delete all pages stats
* @return void
*/
function deleteAllPagesStats( ){
  $rF = fopen( DB_PAGES_STATS, 'w' );
  fwrite( $rF, '<?php exit; ?>'."\n" );
  fclose( $rF );
  @chmod( DB_PAGES_STATS, 0644 );
} // end function deleteAllPagesStats

/**
* Delete all files stats
* @return void
*/
function deleteAllFilesStats( ){
  $rF = fopen( DB_FILES_STATS, 'w' );
  fwrite( $rF, '<?php exit; ?>'."\n" );
  fclose( $rF );
  @chmod( DB_FILES_STATS, 0644 );
} // end function deleteAllFilesStats

/**
* Delete all products stats
* @return void
*/
function deleteAllProductsStats( ){
  $rF = fopen( DB_PRODUCTS_STATS, 'w' );
  fwrite( $rF, '<?php exit; ?>'."\n" );
  fclose( $rF );
  @chmod( DB_PRODUCTS_STATS, 0644 );
} // end function deleteAllProductsStats

/**
* Delete all searched words
* @return void
*/
function deleteAllAllSearchWords( ){
  $rF = fopen( DB_SEARCHED_WORDS, 'w' );
  fwrite( $rF, '<?php exit; ?>'."\n" );
  fclose( $rF );
  @chmod( DB_SEARCHED_WORDS, 0644 );
} // end function deleteAllAllSearchWords

/**
* Assigns keys to stats data
* @return array
* @param array
*/
function dbAssignStats( $aExp ){
  return Array( 'iId' => $aExp[0], 'iTime' => $aExp[1] );
} // end function dbAssignStats

/**
* Assigns keys to files stats data
* @return array
* @param array
*/
function dbAssignFilesStats( $aExp ){
  return Array( 'sFile' => $aExp[0], 'iTime' => $aExp[1] );
} // end function dbAssignFilesStats

/**
* Assigns keys to searched words data
* @return array
* @param array
*/
function dbAssignSearchedWords( $aExp ){
  if( isset( $aExp[1] ) )
    return Array( 'sWords' => $aExp[0], 'iTime' => $aExp[1] );
} // end function dbAssignSearchedWords

/**
* List ordered products
* @return string
* @param string $sDateFrom
* @param string $sDateTo
* @param int    $iStatus1
* @param int    $iStatus2
*/
function listOrderedProductsStats( $sDateFrom, $sDateTo, $iStatus1, $iStatus2 ){
  $aOrders = returnOrdersStats( $sDateFrom, $sDateTo, $iStatus1, $iStatus2, strtolower( LANGUAGE ) );

  if( isset( $aOrders ) ){
    $oProduct = Products::getInstance( );
    
    $i = 0;
    $rFile = fopen( DB_ORDERS_PRODUCTS, 'r' );

    while( !feof( $rFile ) ){
      $sContent = trim( fgets( $rFile ) );
      if( $i > 0 && !empty( $sContent ) ){
        $aData = unserialize( $sContent );
        if( isset( $aOrders[$aData['iOrder']] ) ){
          if( !isset( $aProducts[$aData['iProduct']] ) ){
            $aProducts[$aData['iProduct']]['iQuantity'] = 0;
            $aProducts[$aData['iProduct']]['fSummary'] = 0;
            $aProducts[$aData['iProduct']]['iProduct'] = $aData['iProduct'];
            $aProducts[$aData['iProduct']]['sName']    = $aData['sName'];
          }
          $aProducts[$aData['iProduct']]['iQuantity'] += $aData['iQuantity'];
          $aProducts[$aData['iProduct']]['fSummary']  += ( $aData['iQuantity'] * $aData['fPrice'] );
        }
      }
      $i++;
    } // end while
    fclose( $rFile );

    if( isset( $aProducts ) ){
      rsort( $aProducts );
      $iCount = count( $aProducts );
      if( $iCount > 50 )
        $iCount = 50;
      $content= null;
      
      for( $i = 0; $i < $iCount; $i++ ){
        $aData = $aProducts[$i];
        $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
        $aData['sName'] = isset( $oProduct->aProducts[$aData['iProduct']] ) ? $oProduct->aProducts[$aData['iProduct']]['sName'] : $aData['sName'];
        $aData['fSummary'] = normalizePrice( $aData['fSummary'] );
        $aData['sSummary'] = displayPrice( $aData['fSummary'] );
        $content .= '<tr class="l'.$aData['iStyle'].'"><td><a href="?p=products-form&amp;iProduct='.$aData['iProduct'].'">'.$aData['sName'].'</a></td><td>'.$aData['iQuantity'].'</td><td>'.$aData['sSummary'].'</td></tr>';
      } // end for

      return $content;
    }
  }
} // end function listOrderedProductsStats

/**
* Generate orders array
* @return array
* @param string $sDateFrom
* @param string $sDateTo
* @param int    $iStatus1
* @param int    $iStatus2
* @param string $sLang
*/
function returnOrdersStats( $sDateFrom, $sDateTo, $iStatus1, $iStatus2, $sLang = null ){
  $i = 0;
  $iTimeStart = strtotime( $sDateFrom );
  $iTimeStop = strtotime( $sDateTo.' 23:59:59' );

  $rFile = fopen( DB_ORDERS, 'r' );
  $i = 0;
  while( !feof( $rFile ) ){
    $sContent = fgets( $rFile );
    if( $i > 0 && !empty( $sContent ) ){
      $aData = unserialize( trim( $sContent ) );
      if( $aData['iStatus'] >= $iStatus1 && $aData['iStatus'] <= $iStatus2 && $aData['iTime'] >= $iTimeStart && $aData['iTime'] <= $iTimeStop ){
        if( ( isset( $sLang ) && $sLang == $aData['sLanguage'] ) || !isset( $sLang ) )
          $aReturn[$aData['iOrder']] = true;
      }
    }
    $i++;
  }
  fclose( $rFile );
  if( isset( $aReturn ) )
    return $aReturn;
} // end function returnOrdersStats

/**
* List customers stats
* @return string
* @param string $sDateFrom
* @param string $sDateTo
* @param int    $iStatus1
* @param int    $iStatus2
*/
function listCustomersStats( $sDateFrom, $sDateTo, $iStatus1, $iStatus2 ){
  $aOrders = returnOrdersStats( $sDateFrom, $sDateTo, $iStatus1, $iStatus2 );

  if( isset( $aOrders ) ){
    $oProduct = Products::getInstance( );

    $i = 0;
    $rFile = fopen( DB_ORDERS_PRODUCTS, 'r' );

    while( !feof( $rFile ) ){
      $sContent = trim( fgets( $rFile ) );
      if( $i > 0 && !empty( $sContent ) ){
        $aData = unserialize( $sContent );

        if( isset( $aOrders[$aData['iOrder']] ) ){
          if( !isset( $aOrdersSummary[$aData['iOrder']] ) ){
            $aOrdersSummary[$aData['iOrder']] = 0;
          }
          $aOrdersSummary[$aData['iOrder']] += ( $aData['iQuantity'] * $aData['fPrice'] );
        }
      }
      $i++;
    } // end while
    fclose( $rFile );


    $rFile = fopen( DB_ORDERS, 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sContent = fgets( $rFile );
      if( $i > 0 && !empty( $sContent ) ){
        $aData = unserialize( trim( $sContent ) );
    
        if( isset( $aOrders[$aData['iOrder']] ) ){
          $aData['mCustomer'] = ( isset( $aData['iUser'] ) && $aData['iUser'] > 0 ) ? $aData['iUser'] : strtolower( trim( $aData['sFirstName'].$aData['sLastName'] ) );
          if( !isset( $aCustomers[$aData['mCustomer']] ) ){
            $aCustomers[$aData['mCustomer']]['iQuantity'] = 0;
            $aCustomers[$aData['mCustomer']]['fSummary'] = 0;
            $aCustomers[$aData['mCustomer']]['sName'] = $aData['sFirstName'].' '.$aData['sLastName'];
            $aCustomers[$aData['mCustomer']]['iUser'] = ( isset( $aData['iUser'] ) && $aData['iUser'] > 0 ) ? $aData['iUser'] : null;
          }
          $aCustomers[$aData['mCustomer']]['fSummary'] += isset( $aOrdersSummary[$aData['iOrder']] ) ? $aOrdersSummary[$aData['iOrder']] : 0;
          $aCustomers[$aData['mCustomer']]['iQuantity']++;
        }
      }
      $i++;
    } // end while
    fclose( $rFile );

    if( isset( $aCustomers ) ){
      rsort( $aCustomers );
      $iCount = count( $aCustomers );
      if( $iCount > 50 )
        $iCount = 50;
      $content= null;
      
      for( $i = 0; $i < $iCount; $i++ ){
        $aData = $aCustomers[$i];
        $aData['iStyle'] = ( $i % 2 ) ? 0: 1;
        $aData['fSummary'] = normalizePrice( $aData['fSummary'] );
        $aData['sSummary'] = displayPrice( $aData['fSummary'] );
        $content .= '<tr class="l'.$aData['iStyle'].'"><td>'.( isset( $aData['iUser'] ) ? '<a href="?p=orders-list&sPhrase=&iStatus=&iUser='.$aData['iUser'].'">'.$aData['sName'].'</a>' : $aData['sName'] ).'</td><td>'.$aData['iQuantity'].'</td><td>'.$aData['sSummary'].'</td></tr>';
      } // end for

      return $content;
    }
  }
} // end function listCustomersStats
?>