<?php
/**
* Save page stat
* @param int $iPage
*/
function savePageStat( $iPage ){
  if( defined( 'SAVE_STATS' ) && SAVE_STATS === true ){
    if( !is_file( DB_PAGES_STATS ) )
      file_put_contents( DB_PAGES_STATS, '<?php exit; ?>'."\n" );
    if( isset( $_COOKIE['aStatsVisits'] ) )
      $aStatsVisits = unserialize( $_COOKIE['aStatsVisits'] );
    if( !preg_match('/'.$GLOBALS['config']['exclude_stats_robots'].'|^$/i', $_SERVER['HTTP_USER_AGENT'] ) && !isset( $aStatsVisits[$iPage] ) ){
      $rF = fopen( DB_PAGES_STATS, 'a' );
      fwrite( $rF, $iPage.'$'.time( ).'$'."\n" );
      fclose( $rF );
      $aStatsVisits[$iPage] = 1;
      setcookie( 'aStatsVisits', serialize( $aStatsVisits ), time( ) + 1800 );
    }
  }
} // end function savePageStat

/**
* Save page stat
* @param int $iPage
*/
function saveProductStat( $iProduct ){
  if( defined( 'SAVE_STATS' ) && SAVE_STATS === true ){
    if( !is_file( DB_PRODUCTS_STATS ) )
      file_put_contents( DB_PRODUCTS_STATS, '<?php exit; ?>'."\n" );
    if( isset( $_COOKIE['aStatsProductsVisits'] ) )
      $aStatsProductsVisits = unserialize( $_COOKIE['aStatsProductsVisits'] );
    if( !preg_match('/'.$GLOBALS['config']['exclude_stats_robots'].'|^$/i', $_SERVER['HTTP_USER_AGENT'] ) && !isset( $aStatsProductsVisits[$iProduct] ) ){
      $rF = fopen( DB_PRODUCTS_STATS, 'a' );
      fwrite( $rF, $iProduct.'$'.time( ).'$'."\n" );
      fclose( $rF );
      $aStatsProductsVisits[$iProduct] = 1;
      setcookie( 'aStatsProductsVisits', serialize( $aStatsProductsVisits ), time( ) + 1800 );
    }
  }
} // end function saveProductStat

/**
* Saves searched words
* @param array $aWords
*/
function saveSearchedWords( $aWords ){
  if( defined( 'SAVE_SEARCHED_PHRASES' ) && SAVE_SEARCHED_PHRASES === true ){
    if( !is_file( DB_SEARCHED_WORDS ) )
      file_put_contents( DB_SEARCHED_WORDS, '<?php exit; ?>'."\n" );
    if( isset( $_SESSION['aStatsWords'] ) )
      $aStatsWords = unserialize( $_SESSION['aStatsWords'] );
    if( isset( $GLOBALS['aActions']['o2'] ) )
      return null;

    if( function_exists( 'mb_strtolower' ) )
      $sWordsSorted = mb_strtolower( implode( ' ', $aWords ), 'UTF-8' );
    else
      $sWordsSorted = strtolower_utf8( implode( ' ', $aWords ) );
    $aWordsSorted = explode( ' ', $sWordsSorted );
    sort( $aWordsSorted );
    $sWordsSorted = implode( ' ', $aWordsSorted );
    $sWordsSortedCookie = changeSpecialChars( htmlspecialchars( stripslashes( $sWordsSorted ) ) );
    if( !isset( $aStatsWords[$sWordsSortedCookie] ) ){
      $rF = fopen( DB_SEARCHED_WORDS, 'a' );
      fwrite( $rF, $sWordsSorted.'$'.time( ).'$'."\n" );
      fclose( $rF );
      $aStatsWords[$sWordsSortedCookie] = 1;
      $_SESSION['aStatsWords'] = serialize( $aStatsWords );
    }
  }
} // end function saveSearchedWords

/**
* Save file stat
* @param string $sFile
*/
function saveFileStat( $sFile ){
  if( defined( 'SAVE_FILES_STATS' ) && SAVE_FILES_STATS === true ){
    if( !is_file( DB_FILES_STATS ) )
      file_put_contents( DB_FILES_STATS, '<?php exit; ?>'."\n" );
    if( !preg_match('/'.$GLOBALS['config']['exclude_stats_robots'].'|^$/i', $_SERVER['HTTP_USER_AGENT'] ) ){
      $rF = fopen( DB_FILES_STATS, 'a' );
      fwrite( $rF, $sFile.'$'.time( ).'$'."\n" );
      fclose( $rF );
    }
  }
} // end function saveFileStat

function strtolower_utf8( $sWords ) {
  return utf8_encode( strtolower( utf8_decode( $sWords ) ) );
}
?>