<?php
if( !defined( 'ADMIN_PAGE' ) )
  exit( 'stats plugin by OpenSolution.org' );

require_once DIR_CORE.'stats-admin.php';

if( $p == 'stats-products' )
  $aSelectMenu['bProducts'] = true;
else
  $aSelectMenu['bPages'] = true;
require_once DIR_TEMPLATES.'admin/_header.php'; // include headers
require_once DIR_TEMPLATES.'admin/_menu.php'; // include menu

if( empty( $sDateFrom ) || ( !empty( $sDateFrom ) && !is_date( $sDateFrom ) ) )
  $sDateFrom = date( 'Y-m-d', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) );
if( empty( $sDateTo ) || ( !empty( $sDateTo ) && !is_date( $sDateTo ) ) )
  $sDateTo = date( 'Y-m-d' );

if( isset( $sOption ) && $sOption == 'delete' ){
  if( $p == 'stats-products' )
    deleteAllProductsStats( );
  else
    deleteAllPagesStats( );
  echo '<div id="msg">'.$lang['Operation_completed'].'</div>';
}
if( isset( $iId ) && is_numeric( $iId ) )
  $sName = ( $p == 'stats-products' ) ? ( isset( $oProduct->aProducts[$iId]['sName'] ) ? ' - '.$oProduct->aProducts[$iId]['sName'] : null ) : ( isset( $oPage->aPages[$iId]['sName'] ) ? ' - '.$oPage->aPages[$iId]['sName'] : null );
?>
<h1><img src="<?php echo $config['dir_templates']; ?>admin/img/ico_stats.gif" alt="<?php echo $lang['Stats']; ?>" /><?php echo $lang['Stats']; if( isset( $sName ) ) echo $sName; ?><a href="<?php echo $config['manual_link']; ?>plugins#1.2" title="<?php echo $lang['Manual']; ?>" target="_blank"></a></h1>
<form action="" method="get" id="search" class="stats">
  <fieldset>
    <input type="hidden" name="p" value="<?php echo $p; ?>" />
    <?php echo $lang['Date_from']; ?> <input type="text" name="sDateFrom" value="<?php echo $sDateFrom; ?>" class="input" maxlength="10" />
    <?php echo $lang['Date_to']; ?> <input type="text" name="sDateTo" value="<?php echo $sDateTo; ?>" class="input" maxlength="10" />
    <input type="submit" value="<?php echo $lang['search']; ?> &raquo;" class="submit" /> <?php echo $lang['example']; ?> 2013-02-25
  </fieldset>
</form>
<?php
if( isset( $iId ) && is_numeric( $iId ) ){
  $sStatsList = listStatsForElement( $iId, ( $p == 'stats-products' ) ? true : null );
  if( !empty( $sStatsList ) ){
  ?>
  <table id="list" class="stats" cellspacing="1">
    <thead>
      <tr>
        <td class="id"><?php echo $lang['Date']; ?></td>
        <td class="name"><?php echo $lang['Visits']; ?></td>
      </tr>
    </thead>
    <tbody>
    <?php echo $sStatsList; ?>
    </tbody>
  </table>  
  <?php
  }
  else{
    echo '<div id="msg" class="error">'.$lang['Data_not_found'].'</div>';
  }
}
else{
  $aData = listStats( $sDateFrom, $sDateTo, ( $p == 'stats-products' ) ? true : null );
  if( !empty( $aData ) ){
    ?>
    <table id="list" class="stats" cellspacing="1">
      <thead>
        <tr class="save">
          <td class="pages">
            <?php echo $lang['Pages'].': <ul>'.$aData['sPages'];?></ul>
          </td>
          <td>
            <a href="?p=<?php echo $p; ?>&amp;sOption=delete" onclick="return del( );"><img src="<?php echo $config['dir_templates']; ?>admin/img/ico_del.gif" alt="<?php echo $lang['delete']; ?>" title="<?php echo $lang['delete']; ?>" style="vertical-align:middle;padding:0 5px 0;" /> <?php echo $lang['clear_stats']; ?></a>
          </td>
        </tr>
        <tr>
          <td><?php echo $lang['Name']; ?></td>
          <td class="name"><?php echo $lang['Visits']; ?></td>
        </tr>
      </thead>
      <tfoot>
        <tr class="save">
          <td colspan="2" class="pages">
            <?php echo $lang['Pages'].': <ul>'.$aData['sPages'];?></ul>
          </td>
        </tr>
      </tfoot>
      <tbody>
      <?php echo $aData['sContent']; ?>
      </tbody>
    </table>  
    <?php
  }
  else{
    echo '<div id="msg" class="error">'.$lang['Data_not_found'].'</div>';
  }
}

require_once DIR_TEMPLATES.'admin/_footer.php'; // include footer
?>